﻿${SegmentFile}

Function MakeYYPath
	Exch $0
	${WordReplace} $0 "\" "_" "+" $0
	${WordReplace} $0 ":" "_" "+" $0
	${WordReplace} $0 " " "_" "+" $0
	Exch $0
FunctionEnd

${SegmentInit}
	Var /GLOBAL yyPath
	${XMLReadAttrib} $EXEDIR\App\YY\Launcher.xml "/LauncherInfo/VersionInfo" yyPath $yyPath
!macroend

${SegmentPrePrimary}
	; === 升级目录名
	ClearErrors
	ReadINIStr $0 $DataDirectory\settings\$AppIDSettings.ini $AppIDSettings LastDrive
	ReadINIStr $1 $DataDirectory\settings\$AppIDSettings.ini $AppIDSettings LastDirectory
	${IfNot} ${Errors}
	${AndIfNot} $0$1 == $EXEDIR
		Push "$0$1\App\YY\"
		Call MakeYYPath
		Pop $R0
		Push "$AppDirectory\YY\"
		Call MakeYYPath
		Pop $R1
		Rename "$DataDirectory\duowan\yy4.0\$R0" "$DataDirectory\duowan\yy4.0\$R1"
		
		Push "$0$1\App\YY\$yyPath\"
		Call MakeYYPath
		Pop $R0
		Push "$AppDirectory\YY\$yyPath\"
		Call MakeYYPath
		Pop $R1
		Rename "$DataDirectory\duowan\yy4.0\$R0" "$DataDirectory\duowan\yy4.0\$R1"
	${Endif}
	
	; === 写入XML
	FindFirst $0 $1 "$DataDirectory\duowan\yy4.0\user\*"
	${DoUntil} $1 == ""
		${Select} $1
			${Case2} "." ".."
				Nop
			${CaseElse}
				${IfNotThen} ${FileExists} $DataDirectory\duowan\yy4.0\user\$1\misc.xml ${|} CopyFiles /Silent "$AppDirectory\AppInfo\Launcher\misc.xml" "$DataDirectory\duowan\yy4.0\user\$1\" ${|}
				${XMLWriteText} "$DataDirectory\duowan\yy4.0\user\$1\misc.xml" "/misc/IM/P2PCachePath" "$DataDirectory\FileReceive"
				${XMLWriteText} "$DataDirectory\duowan\yy4.0\user\$1\misc.xml" "/misc/audio/recordFilePath" "$DataDirectory\AudioRecord"
				${IfNotThen} ${FileExists} $DataDirectory\duowan\yy4.0\user\$1\config.xml ${|} CopyFiles /Silent "$AppDirectory\AppInfo\Launcher\config.xml" "$DataDirectory\duowan\yy4.0\user\$1\" ${|}
		${EndSelect}
		FindNext $0 $1
	${Loop}
	FindClose $0
	
	; === 检查流氓快捷方式
	${IfThen} ${FileExists} $DESKTOP\YY游戏大厅.lnk ${|} ${WriteRuntimeData} ShortCutExists 1 true ${|}
	
	; === 注册Dll
	; RegDLL "$AppDirectory\YY\yy_checker.dll"
	
	; === 处理保存到我的文档的文件
	${If} ${FileExists} "$DOCUMENTS\我的YY"
	${AndIfNot} ${FileExists} "$DOCUMENTS\我的YY.BackupBy${APPID}"
		ClearErrors
		Rename "$DOCUMENTS\我的YY" "$DOCUMENTS\我的YY.BackupBy${APPID}"
		${If} ${Errors}
			${WriteRuntimeData} BackupFailed Documents true
		${EndIf}
	${EndIf}
!macroend

${SegmentPostPrimary}
	; === 杀死残余进程
	${Unless} $R0 == ""
		FindFirst $0 $1 "$AppDirectory\YY\$yyPath\*.exe"
		${DoUntil} $1 == ""
			${TerminateProcess} $1 $2
			FindNext $0 $1
		${Loop}
		FindClose $0
	${EndUnless}
	
	; === 删除快捷方式
	${ReadRuntimeData} $1 ShortCutExists 1
	${IfNotThen} $1 == true ${|} Delete $DESKTOP\YY游戏大厅.lnk ${|}
	
	; === 反注册Dll
	; UnRegDLL "$AppDirectory\YY\yy_checker.dll"
	
	; === 处理首次运行时保存到我的文档的文件
	${ReadRuntimeData} $0 BackupFailed Documents
	${IfNot} $0 == true
		${If} ${FileExists} "$DOCUMENTS\我的YY"
			FindFirst $0 $1 "$DOCUMENTS\我的YY\*.*"
			${DoUntil} $1 == ""
				${Select} $1
					${Case2} "." ".."
						Nop
					${CaseElse}
						${If} ${FileExists} "$DOCUMENTS\我的YY\$1\*.*"
							${If} ${FileExists} "$DOCUMENTS\我的YY\$1\频道录音\*.*"
								CreateDirectory "$DataDirectory\AudioRecord"
								CopyFiles /Silent "$DOCUMENTS\我的YY\$1\频道录音\*.*" "$DataDirectory\AudioRecord"
								RMDir /r "$DOCUMENTS\我的YY\$1\频道录音"
							${Endif}
							CreateDirectory "$DataDirectory\FileReceive"
							CopyFiles /Silent "$DOCUMENTS\我的YY\$1\*.*" "$DataDirectory\FileReceive"
						${Endif}
				${EndSelect}
				FindNext $0 $1
			${Loop}
			FindClose $0
			RMDir /r "$DOCUMENTS\我的YY"
		${EndIf}
		Rename "$DOCUMENTS\我的YY.BackupBy${APPID}" "$DOCUMENTS\我的YY"
	${EndIf}
!macroend